searchData={"items":[{"type":"module","doc":"","title":"AshBackpex","ref":"AshBackpex.html"},{"type":"module","doc":"```\n  use Backpex.LiveResource,\n    adapter: InsiWeb.BackpexAshAdapter,\n    adapter_config: [\n      resource: User,\n      schema: User,\n      repo: Insi.Repo,\n      create_action: :create_with_plaintext_pwd,\n      create_changeset: &InsiWeb.BackpexAshAdapter.create_changeset/3,\n      update_changeset: &InsiWeb.BackpexAshAdapter.update_changeset/3,\n      load: &InsiWeb.BackpexAshAdapter.load/3\n    ],\n    layout: {InsiWeb.Layouts, :admin}\n  ```\n\n  You can specify a default create_action or update_action, which must refer to an action on the resource.\n\n  You must specify the create_changeset, update_changeset, and load functions because for some reason Backpex is not respecting the provided default Nimble values.\n  Override them in your resource if necessary.\n\n\n  The `Backpex.Adapter` to connect your `Backpex.LiveResource` to an `Ash.Resource`.\n\n  ## `adapter_config`\n\n  * `:resource` (`t:atom/0`) - Required. The `Ash.Resource` that will be used to perform CRUD operations.\n\n* `:schema` (`t:atom/0`) - Required. The `Ash.Resource` for the resource.\n\n* `:repo` (`t:atom/0`) - Required. The `Ecto.Repo` that will be used to perform CRUD operations for the given schema.\n\n* `:create_action` (`t:atom/0`) - The resource action to use when creating new items in the admin. Defaults to the primary create action.\n\n* `:read_action` (`t:atom/0`) - The resource action to use when reading items in the admin. Defaults to the primary read action.\n\n* `:update_action` (`t:atom/0`) - The resource action to use when updating items in the admin. Defaults to the primary update action.\n\n* `:destroy_action` (`t:atom/0`) - The resource action to use when destroying items in the admin. Defaults to the primary destroy action.\n\n* `:create_changeset` (function of arity 3) - Changeset to use when creating items. Additional metadata is passed as a keyword list via the third parameter:\n  - `:assigns` - the assigns\n  - `:target` - the name of the `form` target that triggered the changeset call. Default to `nil` if the call was not triggered by a form field. The default value is `&AshBackpex.Adapter.create_changeset/3`.\n\n* `:update_changeset` (function of arity 3) - Required. Changeset to use when updating items. Additional metadata is passed as a keyword list via the third parameter:\n  - `:assigns` - the assigns\n  - `:target` - the name of the `form` target that triggered the changeset call. Default to `nil` if the call was not triggered by a form field. The default value is `&AshBackpex.Adapter.update_changeset/3`.\n\n* `:load` (function of arity 3) - Relationships, calculations and aggregates that Ash should load\n  - `[comments: [:author]]` The default value is `&AshBackpex.Adapter.load/3`.\n\n\n\n  >","title":"AshBackpex.Adapter","ref":"AshBackpex.Adapter.html"},{"type":"module","doc":">\n  > The `Backpex.Adapters.Ash` is currently not usable! It can barely list and show items. We will work on this as we continue to implement  the `Backpex.Adapter` pattern throughout the codebase.","title":"Work in progress - AshBackpex.Adapter","ref":"AshBackpex.Adapter.html#module-work-in-progress"},{"type":"function","doc":"Applies a change to a given item.","title":"AshBackpex.Adapter.change/6","ref":"AshBackpex.Adapter.html#change/6"},{"type":"function","doc":"Returns the number of items matching the given criteria.","title":"AshBackpex.Adapter.count/3","ref":"AshBackpex.Adapter.html#count/3"},{"type":"function","doc":"","title":"AshBackpex.Adapter.create_changeset/3","ref":"AshBackpex.Adapter.html#create_changeset/3"},{"type":"function","doc":"Deletes multiple items.","title":"AshBackpex.Adapter.delete_all/2","ref":"AshBackpex.Adapter.html#delete_all/2"},{"type":"function","doc":"Gets a database record with the given primary key value.\n\nReturns `nil` if no result was found.","title":"AshBackpex.Adapter.get/3","ref":"AshBackpex.Adapter.html#get/3"},{"type":"function","doc":"Inserts given item.","title":"AshBackpex.Adapter.insert/2","ref":"AshBackpex.Adapter.html#insert/2"},{"type":"function","doc":"Returns a list of items by given criteria.","title":"AshBackpex.Adapter.list/3","ref":"AshBackpex.Adapter.html#list/3"},{"type":"function","doc":"","title":"AshBackpex.Adapter.load/3","ref":"AshBackpex.Adapter.html#load/3"},{"type":"function","doc":"Updates given item.","title":"AshBackpex.Adapter.update/2","ref":"AshBackpex.Adapter.html#update/2"},{"type":"function","doc":"Updates given items.","title":"AshBackpex.Adapter.update_all/3","ref":"AshBackpex.Adapter.html#update_all/3"},{"type":"function","doc":"","title":"AshBackpex.Adapter.update_changeset/3","ref":"AshBackpex.Adapter.html#update_changeset/3"},{"type":"function","doc":"","title":"AshBackpex.Adapter.validate_config!/1","ref":"AshBackpex.Adapter.html#validate_config!/1"},{"type":"module","doc":"","title":"AshBackpex.LiveResource","ref":"AshBackpex.LiveResource.html"},{"type":"module","doc":"* `:extensions` (list of module that adopts `Spark.Dsl.Extension`) - A list of DSL extensions to add to the `Spark.Dsl`\n\n* `:otp_app` (`t:atom/0`) - The otp_app to use for any application configurable options\n\n* `:fragments` (list of `t:module/0`) - Fragments to include in the `Spark.Dsl`. See the fragments guide for more.","title":"Options - AshBackpex.LiveResource","ref":"AshBackpex.LiveResource.html#module-options"},{"type":"module","doc":"defmodule MyAppWeb.Live.PostLive do\n  use AshBackpex.Live\n\n  backpex do\n    resource MyApp.Blog.Post\n    load [:author, :comments]\n    fields do\n      field :title, Backpex.Fields.Text\n      field :author, Backpex.Fields.BelongsTo\n      field :comments, Backpex.Fields.HasMany, only: [:show]\n    end\n    singular_label \"Post\"\n    plural_label \"Posts\"\n  end\nend","title":"AshBackpex.LiveResource.Dsl","ref":"AshBackpex.LiveResource.Dsl.html"},{"type":"macro","doc":"","title":"AshBackpex.LiveResource.Dsl.backpex/1","ref":"AshBackpex.LiveResource.Dsl.html#backpex/1"},{"type":"module","doc":"","title":"AshBackpex.LiveResource.Dsl.Field","ref":"AshBackpex.LiveResource.Dsl.Field.html"},{"type":"module","doc":"","title":"AshBackpex.LiveResource.Dsl.Filter","ref":"AshBackpex.LiveResource.Dsl.Filter.html"},{"type":"module","doc":"","title":"AshBackpex.LiveResource.Dsl.ItemAction","ref":"AshBackpex.LiveResource.Dsl.ItemAction.html"},{"type":"module","doc":"","title":"AshBackpex.LiveResource.Info","ref":"AshBackpex.LiveResource.Info.html"},{"type":"function","doc":"The create action to be used when creating resources. Will default to the primary create action.","title":"AshBackpex.LiveResource.Info.backpex_create_action/1","ref":"AshBackpex.LiveResource.Info.html#backpex_create_action/1"},{"type":"function","doc":"The create action to be used when creating resources. Will default to the primary create action.","title":"AshBackpex.LiveResource.Info.backpex_create_action!/1","ref":"AshBackpex.LiveResource.Info.html#backpex_create_action!/1"},{"type":"function","doc":"Changeset to use when creating items. Additional metadata is passed as a keyword list via the third parameter:\n- `:assigns` - the assigns\n- `:target` - the name of the `form` target that triggered the changeset call. Default to `nil` if the call was not triggered by a form field.","title":"AshBackpex.LiveResource.Info.backpex_create_changeset/1","ref":"AshBackpex.LiveResource.Info.html#backpex_create_changeset/1"},{"type":"function","doc":"Changeset to use when creating items. Additional metadata is passed as a keyword list via the third parameter:\n- `:assigns` - the assigns\n- `:target` - the name of the `form` target that triggered the changeset call. Default to `nil` if the call was not triggered by a form field.","title":"AshBackpex.LiveResource.Info.backpex_create_changeset!/1","ref":"AshBackpex.LiveResource.Info.html#backpex_create_changeset!/1"},{"type":"function","doc":"The destroy action to be used when destroying resources. Will default to the primary destroy action.","title":"AshBackpex.LiveResource.Info.backpex_destroy_action/1","ref":"AshBackpex.LiveResource.Info.html#backpex_destroy_action/1"},{"type":"function","doc":"The destroy action to be used when destroying resources. Will default to the primary destroy action.","title":"AshBackpex.LiveResource.Info.backpex_destroy_action!/1","ref":"AshBackpex.LiveResource.Info.html#backpex_destroy_action!/1"},{"type":"function","doc":"backpex.fields DSL entities","title":"AshBackpex.LiveResource.Info.backpex_fields/1","ref":"AshBackpex.LiveResource.Info.html#backpex_fields/1"},{"type":"function","doc":"backpex.filters DSL entities","title":"AshBackpex.LiveResource.Info.backpex_filters/1","ref":"AshBackpex.LiveResource.Info.html#backpex_filters/1"},{"type":"function","doc":"backpex.item_actions DSL entities","title":"AshBackpex.LiveResource.Info.backpex_item_actions/1","ref":"AshBackpex.LiveResource.Info.html#backpex_item_actions/1"},{"type":"function","doc":"backpex.item_actions DSL options\n\nReturns a map containing the and any configured or default values.","title":"AshBackpex.LiveResource.Info.backpex_item_actions_options/1","ref":"AshBackpex.LiveResource.Info.html#backpex_item_actions_options/1"},{"type":"function","doc":"Default Backpex actions to remove from the live resource","title":"AshBackpex.LiveResource.Info.backpex_item_actions_strip_default/1","ref":"AshBackpex.LiveResource.Info.html#backpex_item_actions_strip_default/1"},{"type":"function","doc":"Default Backpex actions to remove from the live resource","title":"AshBackpex.LiveResource.Info.backpex_item_actions_strip_default!/1","ref":"AshBackpex.LiveResource.Info.html#backpex_item_actions_strip_default!/1"},{"type":"function","doc":"The liveview layout, e.g.: {MyAppWeb.Layouts, :admin}","title":"AshBackpex.LiveResource.Info.backpex_layout/1","ref":"AshBackpex.LiveResource.Info.html#backpex_layout/1"},{"type":"function","doc":"The liveview layout, e.g.: {MyAppWeb.Layouts, :admin}","title":"AshBackpex.LiveResource.Info.backpex_layout!/1","ref":"AshBackpex.LiveResource.Info.html#backpex_layout!/1"},{"type":"function","doc":"backpex DSL options\n\nReturns a map containing the and any configured or default values.","title":"AshBackpex.LiveResource.Info.backpex_options/1","ref":"AshBackpex.LiveResource.Info.html#backpex_options/1"},{"type":"function","doc":"Any panels to be displayed in the admin create/edit forms.","title":"AshBackpex.LiveResource.Info.backpex_panels/1","ref":"AshBackpex.LiveResource.Info.html#backpex_panels/1"},{"type":"function","doc":"Any panels to be displayed in the admin create/edit forms.","title":"AshBackpex.LiveResource.Info.backpex_panels!/1","ref":"AshBackpex.LiveResource.Info.html#backpex_panels!/1"},{"type":"function","doc":"The plural label for the resource taht will appear i nthe admin. E.g., \"Posts\"","title":"AshBackpex.LiveResource.Info.backpex_plural_label/1","ref":"AshBackpex.LiveResource.Info.html#backpex_plural_label/1"},{"type":"function","doc":"The plural label for the resource taht will appear i nthe admin. E.g., \"Posts\"","title":"AshBackpex.LiveResource.Info.backpex_plural_label!/1","ref":"AshBackpex.LiveResource.Info.html#backpex_plural_label!/1"},{"type":"function","doc":"The read action to be used when reading resources. Will default to the primary read action.","title":"AshBackpex.LiveResource.Info.backpex_read_action/1","ref":"AshBackpex.LiveResource.Info.html#backpex_read_action/1"},{"type":"function","doc":"The read action to be used when reading resources. Will default to the primary read action.","title":"AshBackpex.LiveResource.Info.backpex_read_action!/1","ref":"AshBackpex.LiveResource.Info.html#backpex_read_action!/1"},{"type":"function","doc":"The Ash resource that the Backpex Live resource should be connect to.","title":"AshBackpex.LiveResource.Info.backpex_resource/1","ref":"AshBackpex.LiveResource.Info.html#backpex_resource/1"},{"type":"function","doc":"The Ash resource that the Backpex Live resource should be connect to.","title":"AshBackpex.LiveResource.Info.backpex_resource!/1","ref":"AshBackpex.LiveResource.Info.html#backpex_resource!/1"},{"type":"function","doc":"The singular label for the resource that will appear in the admin. E.g., \"Post\"","title":"AshBackpex.LiveResource.Info.backpex_singular_label/1","ref":"AshBackpex.LiveResource.Info.html#backpex_singular_label/1"},{"type":"function","doc":"The singular label for the resource that will appear in the admin. E.g., \"Post\"","title":"AshBackpex.LiveResource.Info.backpex_singular_label!/1","ref":"AshBackpex.LiveResource.Info.html#backpex_singular_label!/1"},{"type":"function","doc":"The update action to be used when updating resources. Will default to the primary update action.","title":"AshBackpex.LiveResource.Info.backpex_update_action/1","ref":"AshBackpex.LiveResource.Info.html#backpex_update_action/1"},{"type":"function","doc":"The update action to be used when updating resources. Will default to the primary update action.","title":"AshBackpex.LiveResource.Info.backpex_update_action!/1","ref":"AshBackpex.LiveResource.Info.html#backpex_update_action!/1"},{"type":"function","doc":"Changeset to use when updating items. Additional metadata is passed as a keyword list via the third parameter:\n- `:assigns` - the assigns\n- `:target` - the name of the `form` target that triggered the changeset call. Default to `nil` if the call was not triggered by a form field.","title":"AshBackpex.LiveResource.Info.backpex_update_changeset/1","ref":"AshBackpex.LiveResource.Info.html#backpex_update_changeset/1"},{"type":"function","doc":"Changeset to use when updating items. Additional metadata is passed as a keyword list via the third parameter:\n- `:assigns` - the assigns\n- `:target` - the name of the `form` target that triggered the changeset call. Default to `nil` if the call was not triggered by a form field.","title":"AshBackpex.LiveResource.Info.backpex_update_changeset!/1","ref":"AshBackpex.LiveResource.Info.html#backpex_update_changeset!/1"},{"type":"module","doc":"","title":"AshBackpex.LiveResource.Transformers.GenerateBackpex","ref":"AshBackpex.LiveResource.Transformers.GenerateBackpex.html"},{"type":"function","doc":"Callback implementation for  Spark.Dsl.Transformer.after?/1 .","title":"AshBackpex.LiveResource.Transformers.GenerateBackpex.after?/1","ref":"AshBackpex.LiveResource.Transformers.GenerateBackpex.html#after?/1"},{"type":"function","doc":"Callback implementation for  Spark.Dsl.Transformer.after_compile?/0 .","title":"AshBackpex.LiveResource.Transformers.GenerateBackpex.after_compile?/0","ref":"AshBackpex.LiveResource.Transformers.GenerateBackpex.html#after_compile?/0"},{"type":"function","doc":"Callback implementation for  Spark.Dsl.Transformer.before?/1 .","title":"AshBackpex.LiveResource.Transformers.GenerateBackpex.before?/1","ref":"AshBackpex.LiveResource.Transformers.GenerateBackpex.html#before?/1"},{"type":"function","doc":"Callback implementation for  Spark.Dsl.Transformer.transform/1 .","title":"AshBackpex.LiveResource.Transformers.GenerateBackpex.transform/1","ref":"AshBackpex.LiveResource.Transformers.GenerateBackpex.html#transform/1"},{"type":"extras","doc":"# Ash Backpex\n\nYou got your [Ash](https://ash-hq.org/) in my [Backpex](https://backpex.live/). You got your [Backpex](https://backpex.live/) in my [Ash](https://ash-hq.org/).\n\nAn integration library that brings together Ash Framework's powerful resource system with Backpex's admin interface capabilities. This library provides a clean DSL for creating admin interfaces directly from your Ash resources.\n\n> Warning!\n> Backpex itself is pre-1.0 so expect the API to change in a breaking way! Also, it cannot currently take full advantage of Ash authorization policies. For now I would only recommend using it in a high-trust environment such as internal tooling.\n\nThis is a partial implementation - feel free to open a github issue to request additional features or submit a PR if you're into that kind of thing ;)","title":"Ash Backpex","ref":"readme.html"},{"type":"extras","doc":"Add `ash_backpex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ash_backpex, \"~> 0.0.1\"}\n  ]\nend\n```","title":"Installation - Ash Backpex","ref":"readme.html#installation"},{"type":"extras","doc":"```elixir\n# myapp_web/live/admin/post_live.ex\ndefmodule MyAppWeb.Live.Admin.PostLive do\n    use AshBackpex.LiveResource\n\n    backpex do\n      resource MyApp.Blog.Post\n      load [:author]\n      layout({MyAppWeb.Layouts, :admin})\n\n      fields do\n        field :title\n        field :published_at\n\n        field :author do\n          display_field(:name)\n          live_resource(MyAppWeb.Live.Admin.AuthorLive)\n        end\n      end\n\n      filters do\n        filter :state do\n          module MyAppWeb.Live.Admin.Filters.PostStateFilter\n        end\n      end\n    end\nend\n```","title":"Usage - Ash Backpex","ref":"readme.html#usage"},{"type":"extras","doc":"Building this little integration seemed easier than any alternatives to get the admin I wanted, which is a credit to the great work of the Backpex team!","title":"Thanks! - Ash Backpex","ref":"readme.html#thanks"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}